
SETUP_INFO = dict(
    name = 'infi.vendata.vmware_powertools',
    version = '2.3',
    author = 'Arnon Yaari',
    author_email = 'arnony@infinidat.com',

    url = 'http://www.infinidat.com',
    license = 'PSF',
    description = """INFINIDAT Host PowerTools for VMware""",
    long_description = """VMware appliance containing Infinidat tools to manage Infinidat InfiniBox from VMware vCenter, including a VASA server and a plugin for managing volumes, snapshots, and other settings from a vSphere client.""",

    # http://pypi.python.org/pypi?%3Aaction=list_classifiers
    classifiers = [
        "Intended Audience :: Developers",
        "Intended Audience :: System Administrators",
        "License :: OSI Approved :: Python Software Foundation License",
        "Operating System :: OS Independent",
        "Programming Language :: Python",
        "Topic :: Software Development :: Libraries :: Python Modules",
    ],

    install_requires = [
'CherryPy>=5.1.0',
'click>=6.3',
'Cython>=0.23.4',
'docopt>=0.6.2',
'Flask>=0.10.1',
'gevent>=1.0.2',
'httpie>=0.9.3',
'infi.execute>=0.1.4',
'infi.greeter>=0.0.8',
'infi.hbaapi>=0.2.8',
'infi.logs-collector>=0.1.11',
'infi.monotonic-time>=0.1.6',
'infi.pyutils>=1.1.2',
'infi.pyvmomi-wrapper>=0.1.19',
'infi.storagemodel>=0.4.11',
'infi.traceback>=0.3.12',
'infi.vendata.infinibox-credentials-store>=0.1.4',
'infi.vendata.powertools>=2.3',
'infi.ZSI>=2.2.2',
'infinisdk>=69.0',
'ipython>=4.1.2',
'itertools-recipes>=0.1',
'Logbook>=0.12.5',
'Mako>=1.0.4',
'mock>=1.0.1',
'munch>=2.0.4',
'python-cjson>=1.1.0',
'pyvmomi>=6.0.0.4',
'redis>=2.10.5',
'reimport>=1.4.1',
'Routes>=2.2',
'rpyc>=3.3.0',
'setuptools>=19.2.0.1',
'zc.buildout>=2.5.0'
],
    namespace_packages = ['infi', 'infi.vendata'],

    package_dir = {'': 'src'},
    package_data = {'': ['static/css/*.css', 'static/fonts/*.eot', 'static/fonts/*.svg', 'static/fonts/*.ttf', 'static/fonts/*.woff', 'static/fonts/*.otf', 'static/fonts/*.html', 'static/html/*.html', 'static/images/*.png', 'static/images/*.gif', 'static/js/*.js', 'templates/*.mako']},
    include_package_data = True,
    zip_safe = False,

    entry_points = dict(
        console_scripts = [
'infinivmware = infi.vendata.vmware_powertools.scripts:main',
'infinivmware-greeter = infi.vendata.vmware_powertools.scripts.greeter:main',
'infinivmware-log = infi.vendata.vmware_powertools.scripts.log_page:server',
'vm_post_install = infi.vendata.vmware_powertools.scripts.post_install:post_install'
],
        gui_scripts = []),
    )

def setup():
    from setuptools import setup as _setup
    from setuptools import find_packages
    SETUP_INFO['packages'] = find_packages('src')
    _setup(**SETUP_INFO)

if __name__ == '__main__':
    setup()

