
from ..__version__ import __version__

PRODUCT_NAME = "Host PowerTools for VMware"
PRODUCT_DESCRIPTION = PRODUCT_NAME
COMPANY_NAME = 'INFINIDAT, Ltd'
COMPANY_EMAIL = "info@infinidat.com"
PLUGIN_TYPE = "com.vmware.vim.viClientScripts"

def _get_version_numbers():
    from infi.os_info import shorten_version_string
    version_numbers = map(int, shorten_version_string(__version__).split('.'))
    while len(version_numbers) < 4:
        version_numbers.append(0)
    return '.'.join([str(item) for item in version_numbers])

def get_product_version():
    return _get_version_numbers()

def get_product_name():
    return PRODUCT_NAME

def get_product_description():
    return PRODUCT_DESCRIPTION

def get_company_name():
    return COMPANY_NAME

def get_company_email():
    return COMPANY_EMAIL

def get_plugin_type():
    return PLUGIN_TYPE
