from ... import PROJECTROOT
from logging import getLogger
logger = getLogger(__name__)
main_greenlet = None

# not being used in production

class ReloadException(Exception):  # pragma: no cover
    pass

def _sigusr1_handler(*args, **kwargs):  # pragma: no cover
    main_greenlet.throw(ReloadException())

def _get_exclusions():  # pragma: no cover
    return []

def _get_modified_modules():  # pragma: no cover
    from reimport import modified
    modified_list = modified(PROJECTROOT)
    excluded = _get_exclusions()
    [modified_list.remove(module) for module in modified_list if module in excluded]
    return modified_list

def _check_for_changes():  # pragma: no cover
    return len(_get_modified_modules())

def _nothing(*args, **kwargs):  # pragma: no cover
    pass

def _check_for_changes_loop():  # pragma: no cover
    from signal import SIGUSR1
    from gevent import sleep, signal
    from os import getpid, kill
    while True:
        if _check_for_changes():
            kill(getpid(), SIGUSR1)
            signal(SIGUSR1, _nothing)
        sleep(1)

def _exec():
    import os
    import sys
    os.execv(sys.argv[0], sys.argv)

def autoreload(func):  # pragma: no cover
    from infi.pyutils.decorators import wraps
    @wraps(func)
    def callable(*args, **kwargs):
        from gevent import signal, spawn, getcurrent
        from signal import SIGUSR1
        global main_greenlet
        main_greenlet = getcurrent()
        signal(SIGUSR1, _sigusr1_handler)
        spawn(_check_for_changes_loop)
        try:
            func(*args, **kwargs)
        except ReloadException:
            _exec()
        logger.info('bye')
    return callable
