LOG_PAGE_TEMPLATE = """
<!DOCTYPE html>
<html>
<body>
<pre>
${contents}
</pre>
</body>
</html>
"""

def server():
    from logging import basicConfig, getLogger
    from infi.vendata.vmware_powertools.scripts.greeter import ERROR_LOGFILE
    from infi.vendata.vmware_powertools.scripts.upstart import signal_init_that_i_am_ready
    from flask import Flask
    from mako.template import Template
    app = Flask(__name__)

    @app.route("/")
    def hello():
        try:
            with open(ERROR_LOGFILE) as fd:
                contents = fd.read().splitlines()[3:]
                if not contents:
                    raise RuntimeError("empty page")
                return Template(LOG_PAGE_TEMPLATE).render(contents="\n".join(contents))
        except:
            getLogger(__name__).exception("failed to render template")
            return "Nothing to see here."

    basicConfig()
    signal_init_that_i_am_ready()
    app.run(host='0.0.0.0', port=5430)
