import cherrypy
import logging
from ..resource import PluginResource

logger = logging.getLogger(__name__)

class Redirect(PluginResource):
    @cherrypy.expose
    def host(self, *args, **kwargs):
        return self._redirect()

    @cherrypy.expose
    def cluster(self, *args, **kwargs):
        return self._redirect()

    @cherrypy.expose
    def virtualmachine(self, *args, **kwargs):
        return self._redirect()

    @cherrypy.expose
    def datastore(self, *args, **kwargs):
        return self._redirect()

    @cherrypy.expose
    def folder(self, *args, **kwargs):
        return self._redirect()

    def _redirect(self):
        from time import time
        url = self.get_url_from_request().replace('redirect', 'views')
        timestamp = time()
        logger.debug("redirecting to {}".format(url))
        return self.template_lookup.get_template("redirect.mako").render(url=url, timestamp=timestamp)
