from infi.vendata.vmware_powertools.webapp.plugin.resource import PluginResource
from infi.vendata.vmware_powertools.webapp.plugin.views.host.operations.resize import HostResizeVolumeTask
from infi.vendata.vmware_powertools.webapp import json_response
from infi.vendata.vmware_powertools.mapping import get_all_mappings_in_cluster
from infi.vendata.vmware_powertools.webapp.plugin.views.host.operations.utils import fix_serial
from infi.vendata.vmware_powertools.webapp.plugin.views.host.operations.provision import convert_size
from infi.vendata.vmware_powertools.vcenter.shortcuts import moref_to_object


class Resize(PluginResource):
    @json_response
    def resize_validation(self, moref, device_name, size, **kwargs):
        esx_cluster = moref_to_object(moref)
        proper_serial = fix_serial(device_name)
        host_mappings = get_all_mappings_in_cluster(esx_cluster, proper_serial)
        host = host_mappings[0]
        proper_size = convert_size(size)
        return HostResizeVolumeTask(host, proper_serial, proper_size).assert_resize_available()

    @json_response
    def get_resize_tasks(self, moref, device_name, **kwargs):
        esx_cluster = moref_to_object(moref)
        host = esx_cluster.host[0]
        proper_serial = fix_serial(device_name)
        proper_size = 0
        return HostResizeVolumeTask(host, proper_serial, proper_size).get_task_list()

    @json_response
    def run_resize_task(self, moref, device_name, size, **kwargs):
        # Note: device_name contains the volume serial
        esx_cluster = moref_to_object(moref)
        task_key = (HostResizeVolumeTask, moref)
        proper_serial = fix_serial(device_name)
        proper_size = convert_size(size)
        # Find a host to perform the resize with
        host_mappings = get_all_mappings_in_cluster(esx_cluster, proper_serial)
        host = host_mappings[0]
        task_object_creator = lambda: HostResizeVolumeTask(host, proper_serial, proper_size)
        return self.next_task_step(task_key, task_object_creator)
