def remove_hosts_from_cluster(system_object, cluster_object, esx_cluster):
    from .queries import get_all_host_objects
    host_objects_that_should_stay = get_all_host_objects(system_object, cluster_object, esx_cluster)
    for host in set(cluster_object.get_hosts()).difference(host_objects_that_should_stay):
        remove_host_from_cluster(cluster_object, host)

def rename_cluster(cluster_object, expected_cluster_name):
    cluster_object.update_name(expected_cluster_name)

def remove_host_from_cluster(cluster_object, host_object):
    cluster_object.remove_host(host_object)

def delete_cluster(cluster_object):
    cluster_object.delete()

def refresh_storage_model(esx_cluster, predicate=None):
    # This method is kept for backwards compatibility and patchability
    from infi.vendata.vmware_powertools.utils import refresh_storage_model_on_cluster
    refresh_storage_model_on_cluster(esx_cluster, predicate=predicate, do_rescan=False, do_refresh=True)

def create_cluster(system_object, expected_cluster_name):
    return system_object.host_clusters.create(name=expected_cluster_name)

def add_host_to_cluster(cluster_object, host_object):
    cluster_object.add_host(host_object)
