from infi.vendata.vmware_powertools.vcenter.shortcuts import create_vcenter_task


class HostMapVolume(object):
    def _mount_datastore(self):
        self._task.set_description("Mounting datastore")
        self._operation.mount_datastore()

    def _map_volume(self):
        from infi.vendata.vmware_powertools.utils import refresh_storage_model_on_host
        self._task.set_description("Mapping volume")
        self._operation.map_to_host()
        refresh_storage_model_on_host(self._esx_host)

    def map(self, esx_host, system_serial, volume_id):
        from infi.vendata.vmware_powertools.vcenter.map import MapVolume
        self._esx_host = esx_host
        self._task = create_vcenter_task(esx_host, "Volume map")
        self._operation = MapVolume(esx_host, int(system_serial), int(volume_id))
        steps = [self._map_volume, self._mount_datastore]
        self._task.step(steps)
