var editable = {
    finish_editing_callback: function(rootElement, editElement, originalText, cancel) {
        if (rootElement.prop("editing") == false) return;
        var newText = editElement.val();
        childElement = editElement.parent();
        childElement.text(cancel ? originalText : newText);
        rootElement.prop("editing", false);
        if (!cancel && originalText != newText) {
            childElement.trigger("edited");
        }
    },
    
    blur_callback: function(rootElement, originalText) {
        var callback = function() {
            editable.finish_editing_callback(rootElement, jQuery(this), originalText, false);
        };
        return callback;
    },

    keydown_callback: function(rootElement, originalText) {
        var callback = function(event) {
            if (event.which == 13 && !event.shiftKey) {
                event.preventDefault();
                editable.finish_editing_callback(rootElement, jQuery(this), originalText, false);
            }
            else if (event.which == 27) {
                editable.finish_editing_callback(rootElement, jQuery(this), originalText, true);
            }
        };
        return callback;
    },
        
    make_editable_class: function(selElement, className, newElement) {
        jQuery(className, selElement).parent().click(
        function() {
            rootElement = jQuery(this);
            childElement = jQuery(className, rootElement);
            editElement = jQuery(newElement);
            if (rootElement.prop("editing")) return;
            rootElement.prop("editing", true);
            var text = childElement.text();
            childElement.text('');
            editElement.appendTo(childElement).val(text).select().blur(editable.blur_callback(rootElement, text)).keydown(editable.keydown_callback(rootElement, text))
        });
    },
    
    make_editable: function(selElement) {
        editable.make_editable_class(selElement, '.editable-box', '<input type="text" class="editable-text-textbox"/>');
        editable.make_editable_class(selElement, '.editable-area', '<textarea class="editable-text-textarea"/>');
    }
}