// HPTVM-857 make the log search case insensitive
// https://css-tricks.com/snippets/jquery/make-jquery-contains-case-insensitive/
$.expr[":"].contains = $.expr.createPseudo(function(arg) {
    return function( elem ) {
        return $(elem).text().toUpperCase().indexOf(arg.toUpperCase()) >= 0;
    };
});

$(function() {

    // Make column widths fixed to prevent them from changing when filtering the table (except for the last one)
    for (var index = 0; index < 3; index++) {
        var td = $('#log-entries tr:first td').get(index);
        $('#log-entries colgroup col').eq(index).attr('width', $(td).outerWidth());
    }

    set_table_height();
    $(window).resize(set_table_height);

});

function set_table_height() {
    $('#log').height($(window).height() - 68);
}

// Make the :contains selector case-insensitive
jQuery.expr[":"].Contains = jQuery.expr.createPseudo(function(arg) {
    return function( elem ) {
        return jQuery(elem).text().toLowerCase().indexOf(arg.toLowerCase()) >= 0;
    };
});

// Show only rows that contain the query string
function filter() {
    var q = $('#q').val().trim();
    $('#log-entries tr').removeClass('hidden');
    if (q != '') {
        $('#log-entries tr:not(:contains("' + q + '"))').addClass('hidden');
    }
}

// Call filter when the user stops typing

$(document).ready(function() {
    timer = 0;
    $('#q').on('keyup', function(e) {
        if (timer) {
            clearTimeout(timer);
        }
        timer = setTimeout(filter, 400);
    });
});
