var readiness = {
    prepare_host: function(callback) {
        var ajaxOptions = {type: "POST", dataType: "json", cache: false, url: readiness.ajaxSource, data: {silent: 'true'}};
        view.spinAjax(ajaxOptions, function() {
            readiness.msg = null;
            if (callback) callback();
        });
    },

    prepare_host_popup: function(callback) {
        $("#readinesss-reason").text(readiness.msg);
        $("#readiness-container").dialog({
            dialogClass: "no-close",
            closeOnEscape: false,
            modal: true,
            width: 540,
            height: 250,
            resizable: false,
            buttons: [
                {
                    text: "PREPARE " + entity_name.toUpperCase(),
                    click: function() {
                        $(this).dialog("close");
                        readiness.prepare_host(callback);
                    }
                }
            ]
        });
    },

    check_if_ready: function(silent) {
        readiness.msg = null;
        var ajaxOptions = {type: "GET", dataType: "json", cache: false, url: readiness.ajaxSource, data: {silent: silent}};
        var done_callback = function(json) {
            if (json.return_value != true) {
                readiness.msg = json.return_value;
                if (!silent) readiness.prepare_host_popup();
            }
            else {
                if (!silent) {
                    $("#readiness-ok-message").dialog({
                        modal: true,
                        width: 540,
                        height: 200,
                        resizable: false,
                        buttons: {
                            'OK': function() {
                                $(this).dialog("close");
                            }
                        }
                    });
                }
            }
        };
        view.spinAjax(ajaxOptions, done_callback);
    },

    with_provisioning_enabled: function(callback) {
        // Used before volume operations to ensure that they can run
        if (readiness.msg) {
            readiness.prepare_host_popup(callback);
        }
        else {
            callback();
        }
    },

    init: function(ajaxSource) {
        readiness.ajaxSource = ajaxSource;
        readiness.check_if_ready(true);
    }
}
