var registration = {
    getCallbackUpdateResult: function(selInfinibox, ajaxSource) {
        var callback = function (json) {
            var info = infinibox.getInfo(selInfinibox);
            if (!infinibox.isSupported(selInfinibox)) {
                return null;
            }
            if (json.return_value == true) {
                info.removeClass("unregistered");
                infinibox.getActionContainer(selInfinibox).show();
                view.select(".not-registered", info).hide();
            } else {
                infinibox.getRegistrationButton(selInfinibox).show();
                view.select(".not-registered", info).show();
                info.addClass("unregistered");
            }
        }
        return callback;
    },

    getRegisterHandler: function(selInfinibox, ajaxSource) {
        var callback = function() {
            var serial = infinibox.getSerial(selInfinibox);
            auth.spin_call_with_credentials(serial,
                function() {
                    var data = {serial: serial};
                    var ajaxOptions = {type: "POST", dataType: "json", data: data,
                                       cache: false, url: ajaxSource};
                    if (!infinibox.isSupported(selInfinibox)) {
                        return;
                    }
                    var callback = registration.getUpdateCallback(selInfinibox, ajaxSource);
                    infinibox.getRegistrationButton(selInfinibox).hide();
                    view.select(".not-registered", selInfinibox).hide();
                    view.spinAjax(ajaxOptions, null, null, callback);
                }
            );
        }
        return callback;
    },

    update: function(divInfinibox, ajaxSource) {
        var selInfinibox = jQuery(divInfinibox);
        var serial = infinibox.getSerial(selInfinibox);
        var data = {serial: serial};
        var ajaxOptions = {type: "GET", dataType: "json", data: data,
                           cache: false, url:ajaxSource};
        if (!infinibox.isSupported(selInfinibox)) {
            return;
        }
        var callback = registration.getCallbackUpdateResult(selInfinibox, ajaxSource);
        view.spinAjax(ajaxOptions, callback);
        view.select(".not-registered", divInfinibox).hide();
        infinibox.getActionContainer(divInfinibox).hide();
        infinibox.getRegistrationButton(divInfinibox).hide();
    },

    getUpdateCallback: function(divInfinibox, ajaxSource) {
        var callback = function() {
            registration.update(divInfinibox, ajaxSource);
        }
        return callback;
    },

    setFixOnAll: function(ajaxSource) {
        var foreach = function(index, divInfinibox) {
            var selInfinibox = jQuery(divInfinibox);
            if (!infinibox.isSupported(selInfinibox)) {
                return;
            }
            var button = infinibox.getRegistrationButton(selInfinibox);
            var callback = registration.getRegisterHandler(selInfinibox, ajaxSource);
            button.click(callback);
        }
        jQuery(".infinibox.root").each(foreach);
    },

    updateAll: function(ajaxSource) {
        var foreach = function(index, divInfinibox) {
            registration.update(divInfinibox, ajaxSource);
        }
        jQuery(".infinibox.root").each(foreach);
    },

    init: function(ajaxSource) {
        registration.setFixOnAll(ajaxSource);
        registration.updateAll(ajaxSource);
    }
}
