var virtualmachine = {

    initDataTable: function(sources) {
        var options = view.getDataTableOptions();
        options.columns = [{name: 'name',        data: 'name',        title: "Snapshot Name",        width: "25%"},
                           {name: 'date',        data: 'date',        title: "Date Created",         width: "10%"},
                           {name: 'description', data: 'description', title: "Description",          width: "45%"},
                           {name: 'consistent',  data: 'consistent',  title: "Consistency Snapshot", width: "10%"},
                           {name: 'actions',     data: 'actions',     title: "Actions",              width: "192px", orderable: false}];
        options.language = {zeroRecords: "No snapshots", search: "", loadingRecords: " ", processing: " "};
        options.dom = "C" + options.dom;    // ColVis
        options.colVis = {
            align: "right",
            buttonText: " ",
            exclude: [0, 4]
        };
        var table = $("#snapshot_table").dataTable(options);
        // hack to prevent sZeroRecords from displaying until loading is done
        table.api().row.add({
            name:        ' ',
            date:        ' ',
            description: ' ',
            consistent:  ' ',
            actions:     ' '
        });
        table.api().draw();
        virtualmachine.loadData();
    },

    loadData: function() {
        // Load the json list of snapshots and insert them into the datatable
        var table = $("#snapshot_table").dataTable();
        var actions_template = _.template($('#snapshot_actions_template').html());
        if (table.length > 0) {
            ajaxOptions = {dataType: 'json', type: 'POST', url: sources.snapshot_table};
            table.api().clear();
            view.spinAjax(ajaxOptions, function(data) {
                _.each(data.return_value, function(snap_info) {
                    var row = {
                        name:        snap_info.snapshot_name,
                        date:        snap_info.snapshot_time,
                        description: snap_info.snapshot_description,
                        consistent:  snap_info.consistency_snapshot ? "Yes" : "No",
                        actions:     actions_template(snap_info)
                    };
                    table.api().row.add(row);
                });
                table.api().draw();
            });
        }
    },

    getCallbackOnLoad: function(sources) {
        var callback = function() {
            $(".expand").toggle();
            $(".hidden").hide();
            tooltip.create($('#alias-tooltip'), "This alias will be used as the " +
                "name <br>of the snapshot object on the InfiniBox");
            virtualmachine.initDataTable(sources);
            reload.init(sources.refresh);
            operations.init(sources.operations);
        }
        return callback;
    }
}
