// extends view.js from powertools

view.name = "VMware PowerTools";

view.getLogMessage = function() {
    var collect_logs_path = "/plugin/logs/collect" + document.location.search;
    return 'Please <a target="_blank" href="' + collect_logs_path + '">download the logs</a> for troubleshooting.'
}

var vmware_view = {
    showLogs: function() {
        window.location.href = "/plugin/logs" + document.location.search;
    },

    collectLogs: function() {
        window.location.href = "/plugin/logs/collect" + document.location.search;
    }
}


// extends rename_modal.js from powertools

rename_modal.done_callback = function(target) {
    var name = $("#rename-modal-name").val().trim();
    if (name === "") {
        showError("ERROR", "ERROR: Volume name cannot be empty");
        return;
    }
    data = {name: name,
            rename_datastore: $("#rename-modal-datastore").is(":checked"),
            rename_device: $("#rename-modal-device").is(":checked")};
    operations.perform_operation(target, sources.operations.rename, data, rename_modal.close_popup);
};

rename_modal.height = 340;

// extends create_vol_modal.js from powertools

create_vol_modal.get_provision_parameters = function() {
    return {serial: $("#vol-modal-serial").val(),
            volume_name: $("#vol-modal-vol-name").val(),
            pool_name: $("#vol-modal-select-pool").val(),
            volume_size: $("#vol-modal-size-text").val() + $("#vol-modal-size-unit").val(),
            thin: $("#vol-modal-thickthin").is(":checked"),
            count: $("#vol-modal-count").val(),
            do_filesystem: $("#vol-modal-create-fs").is(":checked"),
            set_device_name: $("#vol-modal-set-device-name").is(":checked")
        };
};

create_vol_modal.capacity_multiplier = 1024;
create_vol_modal.height = 460;