#!/usr/bin/env python

# Copyright 2009 VMware, Inc.  All rights reserved.

import sys
import os
import sys
import time
import getopt

sys.path.append("/opt/vmware/lib/python/site-packages/")
import pywbem

CIM_SERVER_URL = 'https://localhost:5489'
DEFAULT_CIM_NAMESPACE = 'root/cimv2'
SFCB_CERT_FILE    = '/opt/vmware/etc/sfcb/client.pem'
SFCB_KEY_FILE     = '/opt/vmware/etc/sfcb/file.pem'

#
# get cim connection to local sfcb
#
def getCIMConnection (url, namespace):
    cred = {}
    cred ['cert_file'] = SFCB_CERT_FILE
    cred ['key_file'] = SFCB_KEY_FILE
    cliconn = pywbem.WBEMConnection (url, None, namespace, cred)
    return cliconn

def getDefaultCIMConnection ():
    return getCIMConnection (CIM_SERVER_URL, DEFAULT_CIM_NAMESPACE)


def invokeNonStaticMethod (namespace, className, methodName):
  cliconn = getCIMConnection (CIM_SERVER_URL, namespace)
  if cliconn != None:
    insts = cliconn.EnumerateInstanceNames(className)
    for inst in insts:
      rettuple = cliconn.InvokeMethod(methodName, inst)
      return rettuple
