#!/usr/bin/env python

# Copyright 2009-2011 VMware, Inc.  All rights reserved.

import sys
import os
import sys
import time
import getopt

sys.path.append("/opt/vmware/lib/python/site-packages/")

LOG_ERROR   = "ERROR"
LOG_WARNING = "warning"
LOG_INFO    = "info"

#
# log file support
#
class logfile:
    """Maintain a log file"""

    def __init__(self, logfile):
        self.file = logfile
        d = os.path.dirname(logfile)
        if ( not os.path.exists(d) ):
            # consider the race between os.path.exists() and os.makedirs(), catch except is necessary
            try:
                os.makedirs(d)
            except OSError:
                pass
                    
    def message(self, level, msg, stdout = False):
        msg = msg.strip()
        if stdout:
            print msg
            #
            # simulate a line buffered mode by flushing stdout after
            # every log message.
            #
            sys.stdout.flush()

        if self.file:
            #
            # DD/MM/YYYY HH:MM:SS [info] message
            #
            st = time.strftime("%d/%m/%Y %H:%M:%S") + \
                                " [" + level + "] " "[process id: %d" % (os.getpid(), ) + "] " + msg + "\n"
            try:
                fd = open(self.file, "a")
                fd.write(st)
                fd.close()
            except Exception, errmsg:
                # if there is an exeception writing to log file let's ignore it
                # this shouldn't happen 
                print "Unable to write to log file (%s): %s" % ( self.file, str(errmsg) )

